package src;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.LinkedHashSet;
import java.util.Set;
import java.util.Vector;
public class Algorithm {
	
	public int[][]  reduce(int H,int[][] T){
		int n = T.length; int bad_node =-1;
		int d = Integer.MAX_VALUE;
		for(int i=0;i<n;i++)if(T[i][1]<d) d = T[i][1];
		//System.out.println("d="+d);
		int d_path = T[0][1];boolean truncate = false;
		for(int k =1;k<n;k++){
			//forward move
			if(T[k][0]==0)T[k][0]=1;
			d_path = d_path+T[k][1];
			if(d_path>=H){bad_node = k; break;}
			//System.out.println("Forward Move[-->"+k+"]:");pd(P);pb(I);System.out.println();
			if(T[k][4] == 1 ){
				int v = k;
				do{
					//backward move
					//System.out.println(v+" "+k+" "+d_path+" "+T[k][1]);
					d_path = d_path - T[k][1];
					//System.out.println("v="+v+" k="+k+" path="+d_path+" T[k][1]="+T[k][1]+" T[v][3]"+T[v][3]);
					T[k][0]=2;	
					//end of backward move
					//System.out.println("Backward Move["+v+"-->"+k+"]:");pd(P);pb(I);System.out.println();						
					v = T[v][3];
				}while(v!=0 && !noGreaterSucc(T,v));
			}
			//if(truncate){k=T[k][3];truncate = false;}
		}
		System.out.println(" bad="+bad_node);
		if(bad_node<0) return T;
		else{
			int[][] rT = prune(T,bad_node);
			return reduce(H,rT);
		}
	}
	private int[][] prune(int[][] T,int bn){
		int pred = T[bn][3];
		int tn = bn;
		while(T[tn][4] !=1)tn++;
		
		int[][] newT = new int[T.length-tn+bn-1][T[0].length];
		for(int i=0;i<T.length;i++){
			System.out.print(i+" ");
			for(int j=0;j<T[i].length;j++)
				System.out.print(T[i][j]+" ");
			System.out.println();
		}
		
		System.out.println(" pred["+bn+"]="+pred+" tn="+tn+" newL="+newT.length);
		for(int i=0;i<bn;i++){
			System.out.print(" "+i);
			for(int j=0;j<T[i].length;j++)
				newT[i][j] = T[i][j];
		}
		System.out.println();
		for(int i=tn+1;i<newT.length;i++){
			System.out.print(" "+i+" "+(i-tn+bn+1));
			for(int j=0;j<T[i-tn+bn-1].length;j++)
				newT[i][j] = T[i-tn+bn-1][j];	
			newT[i][3] = T[i-tn+bn-1][3]-1;
		}
		System.out.println();
		if(pred !=0)newT[pred][4]=1;
		for(int i=0;i<newT.length;i++){
			System.out.print(i+" ");
			for(int j=0;j<newT[i].length;j++)
				System.out.print(newT[i][j]+" ");
			System.out.println();
		}
		return newT;
	}
	public void precKnapsack(int H,int[][] someT){
		int[][] T = reduce(H,someT);
		int n = T.length;
		double[][] P = new double[n][H];
		boolean[][] I = new boolean[n][H];
		//initialization
		int d = Integer.MAX_VALUE;
		for(int i=0;i<n;i++)if(T[i][1]<d) d = T[i][1];
		//System.out.println("d="+d);
		for(int h=d;h<T[0][1] -1;h++)	{P[0][h]=Integer.MIN_VALUE; I[0][h] =false;}
		for(int h=T[0][1]; h<H; h++)	{P[0][h]=T[0][2]; I[0][h] =true;}
		//pd(P);pb(I);System.out.println();

		//main loop
		int d_path = T[0][1];boolean truncate = false;
		for(int k =1;k<n;k++){
			//forward move
			if(T[k][0]==0)T[k][0]=1;
			d_path = d_path+T[k][1];
			if(k+1<n && (d_path+T[k+1][1])>=H){ T[k+1][1] = 0;T[k+1][2] = -1;}
			else if((k == n-1) && (d_path>=H)){T[k][4] = 1;}
			else{
			//System.out.println(d+" "+d_path+" "+T[k][1]+" k="+k);
			for(int h = d; h<d_path; h++) P[k][h]=Integer.MIN_VALUE;
			for(int h= d_path;h<H;h++)   P[k][h]= P[T[k][3]][h-T[k][1]]+T[k][2];
			}//end of forward move
			//System.out.println("Forward Move[-->"+k+"]:");pd(P);pb(I);System.out.println();
			if(T[k][4] == 1 ){
				int v = k;
				do{
					//backward move
					//System.out.println(v+" "+k+" "+d_path+" "+T[k][1]);
					d_path = d_path - T[k][1];
					//System.out.println("v="+v+" k="+k+" path="+d_path+" T[k][1]="+T[k][1]+" T[v][3]"+T[v][3]);
					for(int h = d;h<H;h++){
						//System.out.print("P: "+P[T[v][3]][h]+" "+P[v][h]);
						if(P[T[v][3]][h]>=P[v][h])I[v][h]=false;
						else{	P[T[v][3]][h] = P[v][h];	I[v][h]=true;}
					}
					//System.out.println();
					T[k][0]=2;	
					//end of backward move
					//System.out.println("Backward Move["+v+"-->"+k+"]:");pd(P);pb(I);System.out.println();						
					v = T[v][3];
				}while(v!=0 && !noGreaterSucc(T,v));
			}
			//if(truncate){k=T[k][3];truncate = false;}
		}
		//find the solution vector
		byte[] x = new byte[n];
		for(int i=0;i<n;i++)T[i][0]=0;
		for(int i=1;i<n;i++)x[i]=0;
		T[0][0] = 1;
		int i = n-1;
		int h = H-1;
		int tail = -1;
		while(i>0 && h>0){
			while(T[i][0] == 0){
				//System.out.println("i="+i+" h="+h+" I="+I[i][h]);
				if(I[i][h] == false)	{ i--; tail=-1;}
				else	{
					if(tail == -1) tail =i;
					T[i][0]=1;					
					i = T[i][3];
				}
			}
			if(tail == -1) tail =i;
			x[tail] = 1;
			h = h - T[tail][1];
			i =tail -1;
			tail =-1;
		}
		//System.out.println("Table:");pd(P);System.out.println();	
		for(int k =0;k<n;k++)
			if(T[k][0]==1)System.out.print("["+T[k][5]+" "+T[k][6]+"] ");
				
		
	}
	private void pd(double[][] P){
		for(int k=0;k<P.length;k++){
			for(int h=0;h<P[k].length;h++)
				System.out.print(" "+P[k][h]);
			System.out.println();
		}
	}
	private void pb(boolean[][] I){
		for(int k=0;k<I.length;k++){
			for(int h=0;h<I[k].length;h++)
				if(I[k][h])System.out.print(" 1");
				else System.out.print(" 0");
			System.out.println();
		}
	}
	private int pred(int k){
		int ret = -1;
		switch(k){
		case 0:
			break;
		case 1:
		case 8:	
		case 4:
			ret = 0;
			break;
		case 5:
			ret=4;
			break;
		case 2:
		case 3:
			ret=1;
			break;
		case 6:
		case 7:
			ret=5;
			break;
		}
		return ret;
	}
	private boolean noGreaterSucc(int[][] T, int v){
		int m = v/4; int off = v%4;
		if(off == 0) return true;
		else{
			for(int i=v+1;i<=(4*m);i++)if(T[i][0]!=2) return false;
		}
		return true;
		/*switch(v){
		case 0:
			for(int i =1;i<9;i++) if(T[i][0]!=2) return false;
			break;
		case 1:
			for(int i =2;i<=3;i++) if(T[i][0]!=2) return false;
			break;
		case 4:
			for(int i =5;i<=7;i++) if(T[i][0]!=2) return false;
			break;
		case 5:
			for(int i =6;i<=7;i++) if(T[i][0]!=2) return false;
			break;
		case 2:
		case 3:
		case 6:
		case 7:
		case 8:
			break;
		}*/
		//return true;
	}
	public int[] naiveMatch(int F){
		boolean sel[] = this.solveKnapsack(Param.NUM_STREAM,Param.VALUE,Param.DATA_RATE,F*Param.NUM_FRAMES*2);
		
		//proportional fairness
		Vector<Integer> take_idx = new Vector<Integer>();
		Vector<Integer> take_val = new Vector<Integer>();
		for(int i=0;i<sel.length;i++)
			if(sel[i]){
				take_idx.add(i-1);
				take_val.add(Param.DATA_RATE[i-1]);
			}
		for(int i =0;i<take_idx.size();i++)
			System.out.print(take_idx.get(i).intValue()+" ");
		System.out.println("\n Vals:");
		
		for(int i =0;i<take_val.size();i++)
			System.out.print(take_val.get(i).intValue()+" ");
		System.out.println();
		int size = take_val.size();
		int val[] = new int[size];
		for(int i =0;i<size;i++)
			val[i] = take_val.get(i).intValue();
		
		int lcm = findLCM(val)/8;
		int repeat = Param.NUM_FRAMES/lcm;
		System.out.println("lcm="+lcm+" repeat="+repeat);
		int res_idx =0;
		int res[] = new int[Param.NUM_FRAMES]; F=F*2; 
		for(int i=0;i<repeat;i++)
			for(int j=0;j<take_val.size();j++)
				for(int k=0;k<take_val.get(j)/F;k++){
					System.out.println("j="+j+" k="+k);
					res[res_idx++] = take_idx.get(j);
				}
				
		return res;
	}
	public int findLCM(int vals[]){
		int LCM = 1; int GCD =vals[0];
		for(int i=0;i<vals.length;i++){
			GCD = findGCD(GCD,vals[i]);
			LCM = LCM * vals[i];
		}
		System.out.print(GCD+" ");
		for(int i=0;i<vals.length-1;i++)
			LCM = LCM/GCD;
		System.out.println(LCM+"");
		return LCM;
	}
	public int findGCD(int a, int b){
		int ta = Math.max(a, b);int tb=Math.min(a, b);
		a = ta; b=tb;
		int q = a/b; int r=a%b;
		while(r!=0){
			ta = a;
			a = b;
			b = ta - q*b;
			q = a/b;
			r = a%b;
		}
		//System.out.println(b+"");
		return b;
	}
	/*public int[] findMatch(int data[][], int frame[][] ){
		int size = Math.max(data.length, frame.length);
		float wt_matrix[][] = new float[size][size];
		for(int i=0;i<size;i++)
			for(int j=0;j<size; j++)
				if(frame[j][1] <= data[i][1] && data[i][0] <= frame[j][0])
					wt_matrix[i][j] = data[i][2];
				else
					wt_matrix[i][j] = 0;
		int result[][] = computeAssignments(wt_matrix);
		int idx_list[] = new int[frame.length];
		for(int i=0;i<size;i++)
			for(int j=0;j<size; j++)
				if(frame[j][1] <= data[i][1] && data[i][0] <= frame[j][0])
					wt_matrix[i][j] = data[i][2];
				else
					wt_matrix[i][j] = 0;
		return idx_list;
	}*/
	public boolean[] solveKnapsack(int N, int pft[],int wt[],int W){
		int[] profit = new int[N+1];
        int[] weight = new int[N+1];

        // generate random instance, items 1..N
        for (int n = 1; n <= N; n++) {
            profit[n] = pft[n-1];
            weight[n] = wt[n-1];
        }
        // opt[n][w] = max profit of packing items 1..n with weight limit w
        // sol[n][w] = does opt solution to pack items 1..n with weight limit w include item n?
        int[][] opt = new int[N+1][W+1];
        boolean[][] sol = new boolean[N+1][W+1];

        for (int n = 1; n <= N; n++) {
            for (int w = 1; w <= W; w++) {

                // don't take item n
                int option1 = opt[n-1][w];

                // take item n
                int option2 = Integer.MIN_VALUE;
                //System.out.println(" n="+n+" w="+w);
                if (weight[n] <= w) option2 = profit[n] + opt[n-1][w-weight[n]];

                // select better of two options
                opt[n][w] = Math.max(option1, option2);
                sol[n][w] = (option2 > option1);
            }
        }
	
        for (int n = 1; n <= N; n++) {
            for (int w = 1; w <= W; w++) {
            	System.out.print(opt[n][w]+" ");
            }
            System.out.println();
        }

        // determine which items to take
        boolean[] take = new boolean[N+1];
        for (int n = N, w = W; n > 0; n--) {
            if (sol[n][w]) { take[n] = true;  w = w - weight[n]; }
            else           { take[n] = false;                    }
        }

        // print results
        System.out.println("item" + "\t" + "profit" + "\t\t" + "weight" + "\t" + "take");
        for (int n = 1; n <= N; n++) {
            System.out.println(n + "\t" + take[n] + "\t\t" + weight[n] + "\t" + profit[n]);
        }
        return take;
	}
	
	/*public int[][] computeAssignments(float[][] matrix) {


        // subtract minumum value from rows and columns to create lots of zeroes
        reduceMatrix(matrix);


        // non negative values are the index of the starred or primed zero in the row or column
        int[] starsByRow = new int[matrix.length]; Arrays.fill(starsByRow,-1);
        int[] starsByCol = new int[matrix[0].length]; Arrays.fill(starsByCol,-1);
        int[] primesByRow = new int[matrix.length]; Arrays.fill(primesByRow,-1);

        // 1s mean covered, 0s mean not covered
        int[] coveredRows = new int[matrix.length];
        int[] coveredCols = new int[matrix[0].length];

        // star any zero that has no other starred zero in the same row or column
        initStars(matrix, starsByRow, starsByCol);
        coverColumnsOfStarredZeroes(starsByCol,coveredCols);

        while (!allAreCovered(coveredCols)) {

            int[] primedZero = primeSomeUncoveredZero(matrix, primesByRow, coveredRows, coveredCols);

            while (primedZero == null) {
                // keep making more zeroes until we find something that we can prime (i.e. a zero that is uncovered)
                makeMoreZeroes(matrix,coveredRows,coveredCols);
                primedZero = primeSomeUncoveredZero(matrix, primesByRow, coveredRows, coveredCols);
            }

            // check if there is a starred zero in the primed zero's row
            int columnIndex = starsByRow[primedZero[0]];
            if (-1 == columnIndex){

                // if not, then we need to increment the zeroes and start over
                incrementSetOfStarredZeroes(primedZero, starsByRow, starsByCol, primesByRow);
                Arrays.fill(primesByRow,-1);
                Arrays.fill(coveredRows,0);
                Arrays.fill(coveredCols,0);
                coverColumnsOfStarredZeroes(starsByCol,coveredCols);
            } else {

                // cover the row of the primed zero and uncover the column of the starred zero in the same row
                coveredRows[primedZero[0]] = 1;
                coveredCols[columnIndex] = 0;
            }
        }

        // ok now we should have assigned everything
        // take the starred zeroes in each column as the correct assignments

        int[][] retval = new int[matrix.length][];
        for (int i = 0; i < starsByCol.length;  i++) {
            retval[i] = new int[]{starsByCol[i],i};
        }
        return retval;





    }

    private boolean allAreCovered(int[] coveredCols) {
        for (int covered : coveredCols) {
            if (0 == covered) return false;
        }
        return true;
    }


    private void reduceMatrix(float[][] matrix) {

        for (int i = 0; i < matrix.length; i++) {

            // find the min value in the row
            float minValInRow = Float.MAX_VALUE;
            for (int j = 0; j < matrix[i].length; j++) {
                if (minValInRow > matrix[i][j]) {
                    minValInRow = matrix[i][j];
                }
            }

            // subtract it from all values in the row
            for (int j = 0; j < matrix[i].length; j++) {
                matrix[i][j] -= minValInRow;
            }
        }

        for (int i = 0; i < matrix[0].length; i++) {
            float minValInCol = Float.MAX_VALUE;
            for (int j = 0; j < matrix.length; j++) {
                if (minValInCol > matrix[j][i]) {
                    minValInCol = matrix[j][i];
                }
            }

            for (int j = 0; j < matrix.length; j++) {
                matrix[j][i] -= minValInCol;
            }

        }

    }

    
    private void initStars(float costMatrix[][], int[] starsByRow, int[] starsByCol) {


        int [] rowHasStarredZero = new int[costMatrix.length];
        int [] colHasStarredZero = new int[costMatrix[0].length];

        for (int i = 0; i < costMatrix.length; i++) {
            for (int j = 0; j < costMatrix[i].length; j++) {
                if (0 == costMatrix[i][j] && 0 == rowHasStarredZero[i] && 0 == colHasStarredZero[j]) {
                    starsByRow[i] = j;
                    starsByCol[j] = i;
                    rowHasStarredZero[i] = 1;
                    colHasStarredZero[j] = 1;
                    break; // move onto the next row
                }
            }
        }
    }


    
    private void coverColumnsOfStarredZeroes(int[] starsByCol, int[] coveredCols) {
        for (int i = 0; i < starsByCol.length; i++) {
            coveredCols[i] = -1 == starsByCol[i] ? 0 : 1;
        }
    }


    
    private int[] primeSomeUncoveredZero(float matrix[][], int[] primesByRow,
                                       int[] coveredRows, int[] coveredCols) {


        // find an uncovered zero and prime it
        for (int i = 0; i < matrix.length; i++) {
            if (1 == coveredRows[i]) continue;
            for (int j = 0; j < matrix[i].length; j++) {
                // if it's a zero and the column is not covered
                if (0 == matrix[i][j] && 0 == coveredCols[j]) {

                    // ok this is an unstarred zero
                    // prime it
                    primesByRow[i] = j;
                    return new int[]{i,j};
                }
            }
        }
        return null;

    }

    private void incrementSetOfStarredZeroes(int[] unpairedZeroPrime, int[] starsByRow, int[] starsByCol, int[] primesByRow) {

        // build the alternating zero sequence (prime, star, prime, star, etc)
        int i, j = unpairedZeroPrime[1];

        Set<int[]> zeroSequence = new LinkedHashSet<int[]>();
        zeroSequence.add(unpairedZeroPrime);
        boolean paired = false;
        do {
            i = starsByCol[j];
            paired = -1 != i && zeroSequence.add(new int[]{i,j});
            if (!paired) break;

            j = primesByRow[i];
            paired = -1 != j && zeroSequence.add(new int[]{ i, j });

        } while (paired);


        // unstar each starred zero of the sequence
        // and star each primed zero of the sequence
        for (int[] zero : zeroSequence) {
            if (starsByCol[zero[1]] == zero[0]) {
                starsByCol[zero[1]] = -1;
                starsByRow[zero[0]] = -1;
            }
            if (primesByRow[zero[0]] == zero[1]) {
                starsByRow[zero[0]] = zero[1];
                starsByCol[zero[1]] = zero[0];
            }
        }

    }


    private void makeMoreZeroes(float[][] matrix, int[] coveredRows, int[] coveredCols) {

        // find the minimum uncovered value
        float minUncoveredValue = Float.MAX_VALUE;
        for (int i = 0; i < matrix.length; i++) {
            if (0 == coveredRows[i]) {
                for (int j = 0; j < matrix[i].length; j++) {
                    if (0 == coveredCols[j] && matrix[i][j] < minUncoveredValue) {
                        minUncoveredValue = matrix[i][j];
                    }
                }
            }
        }

        // add the min value to all covered rows
        for (int i = 0; i < coveredRows.length; i++) {
            if (1 == coveredRows[i]) {
                for (int j = 0; j < matrix[i].length; j++) {
                        matrix[i][j] += minUncoveredValue;
                }
            }
        }

        // subtract the min value from all uncovered columns
        for (int i = 0; i < coveredCols.length; i++) {
            if (0 == coveredCols[i]) {
                for (int j = 0; j < matrix.length; j++) {
                    matrix[j][i] -= minUncoveredValue;
                }
            }
        }
    }*/

}
/*
class Vertex {
	  public int label;

	  public Vertex(int lab) {
	    label = lab;
	  }
	}

class GraphTS {
	  private final int MAX_VERTS = 610;

	  private int vertexList[]; // list of vertices

	  private int matrix[][]; // adjacency matrix

	  private int numVerts; // current number of vertices

	  private int sortedArray[];
	  int s[];

	  public GraphTS() {
	    vertexList = new int[MAX_VERTS];
	    matrix = new int[MAX_VERTS][MAX_VERTS];
	    numVerts = 0;
	    for (int i = 0; i < MAX_VERTS; i++)
	      for (int k = 0; k < MAX_VERTS; k++)
	        matrix[i][k] = 0;
	    sortedArray = new int[MAX_VERTS]; // sorted vert labels
	  }

	  public void addVertex(int lab) {
	    vertexList[numVerts++] = lab;//new Vertex(lab);
	  }

	  public void addEdge(int start, int end) {
	    matrix[start][end] = 1;
	  }

	  public void displayVertex(int v) {
	    System.out.print(vertexList[v]);
	  }

	  public int[] topo() // toplogical sort
	  {
	    int orig_nVerts = numVerts; 

	    while (numVerts > 0) // while vertices remain,
	    {
	      // get a vertex with no successors, or -1
	      int currentVertex = noSuccessors();
	      if (currentVertex == -1) // must be a cycle
	      {
	        System.out.println("ERROR: Graph has cycles");
	        return null;
	      }
	      // insert vertex label in sorted array (start at end)
	      sortedArray[numVerts - 1] = vertexList[currentVertex];

	      deleteVertex(currentVertex); // delete vertex
	    }

	    // vertices all gone; display sortedArray
	    //System.out.print("Topologically sorted order: ");
	    s = new int[orig_nVerts];
	    for (int j = 0; j < orig_nVerts; j++){
	    	s[j] = sortedArray[j];
	     // System.out.print(" "+s[j]);
	    }
	    //System.out.println("");
	    return s;
	  }

	  public int noSuccessors() // returns vert with no successors (or -1 if no such verts)
	  { 
	    boolean isEdge; // edge from row to column in adjMat

	    for (int row = 0; row < numVerts; row++) {
	      isEdge = false; // check edges
	      for (int col = 0; col < numVerts; col++) {
	        if (matrix[row][col] > 0) // if edge to another,
	        {
	          isEdge = true;
	          break; // this vertex has a successor try another
	        }
	      }
	      if (!isEdge) // if no edges, has no successors
	        return row;
	    }
	    return -1; // no
	  }

	  public void deleteVertex(int delVert) {
	    if (delVert != numVerts - 1) // if not last vertex, delete from vertexList
	    {
	      for (int j = delVert; j < numVerts - 1; j++)
	        vertexList[j] = vertexList[j + 1];

	      for (int row = delVert; row < numVerts - 1; row++)
	        moveRowUp(row, numVerts);

	      for (int col = delVert; col < numVerts - 1; col++)
	        moveColLeft(col, numVerts - 1);
	    }
	    numVerts--; // one less vertex
	  }

	  private void moveRowUp(int row, int length) {
	    for (int col = 0; col < length; col++)
	      matrix[row][col] = matrix[row + 1][col];
	  }

	  private void moveColLeft(int col, int length) {
	    for (int row = 0; row < length; row++)
	      matrix[row][col] = matrix[row][col + 1];
	  }
}*/
