package src;

public class Layer {  
	Layer pre,rsuc,csuc;
	int SID;
	int LID;
	int rate;
	double psnr;
	boolean flag;
	int numF;
	int label;
	String color;
	public Layer(int sid, int lid,int r,double p) {  
		this.SID = sid;  
		this.LID = lid;
		this.rate = r;
		this.psnr = p;
		this.pre = this.rsuc = this.csuc = null;
		this.flag = false;
		this.numF = r/50;
		if(r%50 !=0) this.numF++;
		//this.label = l;
		color = "white";
	}
	public int getLID() {
		return LID;
	}
	public double getPsnr() {
		return psnr;
	}
	public int getRate() {
		return rate;
	}
	public int getSID() {
		return SID;
	}
	public Layer getPre() {
		return pre;
	}
	public void setPre(Layer pre) {
		this.pre = pre;
	}
	public Layer getRSuc() {
		return this.rsuc;
	}
	public void setRSuc(Layer suc) {
		this.rsuc = suc;
	}
	public Layer getCSuc() {
		return this.csuc;
	}
	public void setCSuc(Layer suc) {
		this.csuc = suc;
	}
	public String toString(){
		return "["+SID+","+LID+","+rate+","+psnr+"]";
	}
	public boolean isLeaf(){ return (this.rsuc==null && this.csuc==null);}
	public boolean isVisited() {
		return flag;
	}
	public void setVisited(boolean flag) {
		this.flag = flag;
	}
	public int getF(){return this.numF;}
	public String getColor() {
		return color;
	}
	public void setColor(String color) {
		this.color = color;
	}
}

