package src;

public class ScalableVideo {
	public String name;
	public int numL;
	int [] data_rates;
	public int[] numF;
	double[] psnrs;
	public ScalableVideo(int L){
		this.numL = L;
		data_rates = new int[L];
		psnrs = new double[L];
	}
	public ScalableVideo(String id, int L) {  
		this.name = id;  
		this.numL = L;
		data_rates = new int[L];
		psnrs = new double[L];
		numF = new int[L];
	}
	public void addInfo(int lid,int rate,double psnr){
		data_rates[lid] = rate;
		psnrs[lid] = psnr;
		//numF[lid] =rate/50;
		//if(rate%50 !=0) numF[lid]++;
	}
	public int getRate(int lid){
		return data_rates[lid];
	}
	public double getPSNR(int lid){
		return psnrs[lid];
	}
	public void print(){
		System.out.print(numL+",");
		for(int i=0;i<numL;i++)	System.out.print(" "+i+", "+data_rates[i]+", "+psnrs[i]);System.out.println();
	}
}
