package test;
import src.ScalableVideo;
import java.io.*;
public class TestCase1 {
	public static void main(String[] args)throws Exception{
		new TestCase1().time_test();
	}
	public void  time_test()throws Exception{
		new File("time_eff.csv").delete();
		PrintWriter pw = new PrintWriter(new FileWriter("time_eff.csv"));	
		for(int m=1;m<=10;m++){
			String str = (m*10)+"";System.out.println(str);
			str = str+","+this.greedy_knapsack(m);System.out.println(str);
			str = str+","+this.test5(m);System.out.println(str);
			pw.println(str);
		}
		pw.close();
	}
	public double  greedy_knapsack(int SM)throws Exception{
		ScalableVideo[][] tsv = TestCase0.getNTData(SM,100);
		long past,total; past = total =0;
		for(int t=0;t<tsv.length;t++){
			int cap = 10*1000;//kbytes
			ScalableVideo[] sv = tsv[t];
			past = System.currentTimeMillis();
			int[] maxl = new TestCase3().solve_knapsack2(sv,cap);
			total = total + System.currentTimeMillis() -past;						
		}
		return(1.0*total/tsv.length);
	}
	public int[][]  reduce(int H,int[][] T){
		int n = T.length; int bad_node =-1;
		int d = Integer.MAX_VALUE;
		for(int i=0;i<n;i++)if(T[i][1]<d) d = T[i][1];
		//System.out.println("d="+d);
		int d_path = T[0][1];
		for(int k =1;k<n;k++){
			//forward move
			if(T[k][0]==0)T[k][0]=1;
			d_path = d_path+T[k][1];
			if(d_path>=H){bad_node = k; break;}
			//System.out.println("Forward Move[-->"+k+"]:");pd(P);pb(I);System.out.println();
			if(T[k][4] == 1 ){
				int v = k;
				do{
					//backward move
					//System.out.println(v+" "+k+" "+d_path+" "+T[k][1]);
					d_path = d_path - T[k][1];
					//System.out.println("v="+v+" k="+k+" path="+d_path+" T[k][1]="+T[k][1]+" T[v][3]"+T[v][3]);
					T[k][0]=2;	
					//end of backward move
					//System.out.println("Backward Move["+v+"-->"+k+"]:");pd(P);pb(I);System.out.println();						
					v = T[v][3];
				}while(v!=0 && !noGreaterSucc(T,v));
			}
			//if(truncate){k=T[k][3];truncate = false;}
		}
		//System.out.println(" bad="+bad_node);
		if(bad_node<0) return T;
		else{
			int[][] rT = prune(T,bad_node);
			return reduce(H,rT);
		}
	}
	private int[][] prune(int[][] T,int bn){
		int pred = T[bn][3];
		int tn = bn;
		while(T[tn][4] !=1)tn++;
		
		int[][] newT = new int[T.length-tn+bn-1][T[0].length];
		/*for(int i=0;i<T.length;i++){
			System.out.print(i+" ");
			for(int j=0;j<T[i].length;j++)
				System.out.print(T[i][j]+" ");
			System.out.println();
		}*/
		
		//System.out.println(" pred["+bn+"]="+pred+" tn="+tn+" newL="+newT.length);
		for(int i=0;i<bn;i++){
			//System.out.print(" "+i);
			for(int j=0;j<T[i].length;j++)
				newT[i][j] = T[i][j];
		}
		//System.out.println();
		for(int i=tn;bn<newT.length;i++,bn++){
			//System.out.print("["+bn+"<--"+(i+1)+"]");
			for(int j=0;j<T[i+1].length;j++)
				newT[bn][j] = T[i+1][j];	
			if(newT[bn][3]!=0)newT[bn][3] = bn-1;// = T[i+1][3]-1;
		}
		//System.out.println();
		if(pred !=0)newT[pred][4]=1;
		/*for(int i=0;i<newT.length;i++){
			System.out.print(i+" ");
			for(int j=0;j<newT[i].length;j++)
				System.out.print(newT[i][j]+" ");
			System.out.println();
		}*/
		return newT;
	}
	public int[][]  precKnapsack(int H,int[][] someT){
		int[][] T = reduce(H,someT);
		int n = T.length;
		double[][] P = new double[n][H];
		boolean[][] I = new boolean[n][H];
		//initialization
		int d = Integer.MAX_VALUE;
		for(int i=0;i<n;i++)if(T[i][1]<d) d = T[i][1];
		//System.out.println("d="+d);
		for(int h=d;h<T[0][1] -1;h++)	{P[0][h]=Integer.MIN_VALUE; I[0][h] =false;}
		for(int h=T[0][1]; h<H; h++)	{P[0][h]=T[0][2]; I[0][h] =true;}
		//pd(P);pb(I);System.out.println();

		//main loop
		int d_path = T[0][1];
		for(int k =1;k<n;k++){
			//forward move
			if(T[k][0]==0)T[k][0]=1;
			d_path = d_path+T[k][1];
			if(k+1<n && (d_path+T[k+1][1])>=H){ T[k+1][1] = 0;T[k+1][2] = -1;}
			else if((k == n-1) && (d_path>=H)){T[k][4] = 1;}
			else{
			//System.out.println(d+" "+d_path+" "+T[k][1]+" k="+k);
			for(int h = d; h<d_path; h++) P[k][h]=Integer.MIN_VALUE;
			for(int h= d_path;h<H;h++)   P[k][h]= P[T[k][3]][h-T[k][1]]+T[k][2];
			}//end of forward move
			//System.out.println("Forward Move[-->"+k+"]:");pd(P);pb(I);System.out.println();
			if(T[k][4] == 1 ){
				int v = k;
				do{
					//backward move
					//System.out.println(v+" "+k+" "+d_path+" "+T[k][1]);
					d_path = d_path - T[k][1];
					//System.out.println("v="+v+" k="+k+" path="+d_path+" T[k][1]="+T[k][1]+" T[v][3]"+T[v][3]);
					for(int h = d;h<H;h++){
						//System.out.print("P: "+P[T[v][3]][h]+" "+P[v][h]);
						if(P[T[v][3]][h]>=P[v][h])I[v][h]=false;
						else{	P[T[v][3]][h] = P[v][h];	I[v][h]=true;}
					}
					//System.out.println();
					T[k][0]=2;	
					//end of backward move
					//System.out.println("Backward Move["+v+"-->"+k+"]:");pd(P);pb(I);System.out.println();						
					v = T[v][3];
				}while(v!=0 && !noGreaterSucc(T,v));
			}
			//if(truncate){k=T[k][3];truncate = false;}
		}
		//find the solution value
		double sol = Double.MIN_VALUE;
		for(int i=0;i<n;i++)
			for(int h=0;h<H;h++)
				if(P[i][h]>sol)sol = P[i][h]; 
		
		//find the solution vector
		byte[] x = new byte[n];
		for(int i=0;i<n;i++)T[i][0]=0;
		for(int i=1;i<n;i++)x[i]=0;
		T[0][0] = 1;
		int i = n-1;
		int h = H-1;
		int tail = -1;
		while(i>0 && h>0){
			while(T[i][0] == 0){
				//System.out.println("i="+i+" h="+h+" I="+I[i][h]);
				if(I[i][h] == false)	{ i--; tail=-1;}
				else	{
					if(tail == -1) tail =i;
					T[i][0]=1;					
					i = T[i][3];
				}
			}
			if(tail == -1) tail =i;
			x[tail] = 1;
			h = h - T[tail][1];
			i =tail -1;
			tail =-1;
		}
		T[0][6] = Math.round((float)sol);
		//System.out.println("Table:");pd(P);System.out.println();	
		//for(int k =0;k<n;k++)
			//if(T[k][0]==1)System.out.print("["+T[k][5]+" "+T[k][6]+"] ");
		return T;		
		
	}
	private void pd(double[][] P){
		for(int k=0;k<P.length;k++){
			for(int h=0;h<P[k].length;h++)
				System.out.print(" "+P[k][h]);
			System.out.println();
		}
	}
	/*private void pb(boolean[][] I){
		for(int k=0;k<I.length;k++){
			for(int h=0;h<I[k].length;h++)
				if(I[k][h])System.out.print(" 1");
				else System.out.print(" 0");
			System.out.println();
		}
	}*/
	private boolean noGreaterSucc(int[][] T, int v){
		int m = v/4; int off = v%4;
		if(off == 0) return true;
		else{
			for(int i=v+1;i<=(4*m);i++)if(T[i][0]!=2) return false;
		}
		return true;
		/*switch(v){
		case 0:
			for(int i =1;i<9;i++) if(T[i][0]!=2) return false;
			break;
		case 1:
			for(int i =2;i<=3;i++) if(T[i][0]!=2) return false;
			break;
		case 4:
			for(int i =5;i<=7;i++) if(T[i][0]!=2) return false;
			break;
		case 5:
			for(int i =6;i<=7;i++) if(T[i][0]!=2) return false;
			break;
		case 2:
		case 3:
		case 6:
		case 7:
		case 8:
			break;
		}*/
		//return true;
	}
	
	public double test5(int SM)throws Exception{
		int NC = 2; long stime =0; int qty =0;
		ScalableVideo[][] tsv = TestCase0.getNTData(SM,100);
		int R = 2*10000;
		//create and solve a knapsack insatnce 
		for(int sec=1;sec<=tsv.length;sec++){
			ScalableVideo[] sv = tsv[sec-1];
			int N = 1;
			for(int i=0;i<sv.length;i++)N= N+sv[i].numL;
			int[][] node = new int[N][7];
			int idx = 1;
			long past = System.currentTimeMillis();		
			for(int i=0;i<node[0].length;i++)node[0][i] =0;
			for(int i=0;i<sv.length;i++){
				node[idx][0] = 0;
				node[idx][1] = sv[i].getRate(0);
				node[idx][2] = Math.round((float)sv[i].getPSNR(0)*1000);
				node[idx][3] = 0;
				node[idx][4] = 0;
				node[idx][5] = i+1;
				node[idx][6] = 0;
				idx++;
				for(int j=1;j<sv[i].numL;j++){
					node[idx][0] = 0;
					node[idx][1] = sv[i].getRate(j);
					node[idx][2] = Math.round((float)sv[i].getPSNR(j)*1000);
					node[idx][3] = idx-1;
					node[idx][4] = 0;
					node[idx][5] = i+1;
					node[idx][6] = j;
					
					idx++;
				}
				node[idx-1][4] = 1;
			}
		
		//for(int i=0;i<node.length;i++)System.out.println(i+" "+node[i][0]+" "+node[i][1]+" "+node[i][2]+" "+node[i][3]+" "+node[i][4]+" "+node[i][5]+" "+node[i][6]);
		int[][] sol = precKnapsack(R, node);
		stime = stime+ (System.currentTimeMillis() -past);
		qty = qty + sol[0][6];
		}
		return (1.0*stime/tsv.length);
	}
	/*public static void test3()throws Exception{
		int P =200;
		int F = 50;
		int t = 5;
		int Q = 100;
		ScalableVideo[] sv = test2();
		int[] sol = {4,4,4,2,4,4,2,4,2,4};
		float[] u = new float[sv.length];
		Job[] job  = new Job[sv.length];
		float[] r = new float[sv.length];
		float[] B = new float[sv.length];
		int[] b = new int[sv.length];
		int[] k = new int[sv.length];
		int[][] y = new int[sv.length][];
		int[][] x = new int[sv.length][];
		int[][] z = new int[sv.length][];
		int[][] e = new int[sv.length][];
		PriorityQueue<SubFrame> pq = new PriorityQueue<SubFrame>(); int tot=0;
		for(int i=0;i<sv.length;i++){
			r[i] = (float)(sv[i].getRate(sol[i]-1)*0.001);
			u[i] = r[i]*1000/2;
			job[i] = new Job(i,Math.round(u[i]/(r[i]*t)),sv[i].numF[sol[i]-1]);
			//pq.add(job[i]);
			b[i] = sv[i].numF[sol[i]-1];
			B[i] = 0;
			k[i] = (b[i]*F)/Q; if(((b[i]*F)%Q)!=0)k[i]++;
			y[i] = new int[k[i]];
			x[i] = new int[k[i]];
			z[i] = new int[k[i]];
			for(int j=0;j<k[i]-1;j++){
				y[i][j] = Q/F;
				x[i][j] = j*Q/b[i];
				z[i][j] = ((j+1)*Q)/b[i];
			}

			y[i][k[i]-1] =((b[i]*F)%Q==0) ? Q/F : b[i]-(k[i]-1)*Q/F;
			x[i][k[i]-1] = k[i]*Q/b[i];
			z[i][k[i]-1] = ((b[i]*F)%Q==0) ? ((k[i]+1)*Q)/b[i] : P;
			System.out.println(i+"["+k[i]+" : "+r[i]+" : "+u[i]+" : "+b[i]+"] ");
			for(int j=0;j<k[i];j++){
				System.out.print("["+x[i][j]+" "+y[i][j]+" "+z[i][j]+"]");
				pq.add(new SubFrame(i,j,x[i][j],y[i][j],z[i][j],0));
			}
			tot =tot+k[i];
			System.out.println();
		}
		System.out.println("total k= "+tot);
		int[] slot = new int[P];
		for(int p=0;p<P;p++){
			SubFrame curr = pq.peek();
			if(isDPoint(p,x,curr)){
				curr = pq.peek();
				if(curr.getA()>=curr.getY())curr = pq.poll();
				else {
					int temp = curr.getA();
					curr.setA(temp++);
				}
				slot[p] = curr.getS();
			}
		}
		for(int p=0;p<P;p++){
			System.out.print(" "+slot[p]);
		}
		
	}
	public static boolean isDPoint(int p,int[][] x,SubFrame cur){
		if(cur.getA()>=cur.getY())	return true;
		for(int s=0;s<x.length;s++)
			for(int k =0;k<x[s].length;k++)
				if(x[s][k]==p) return true;
		return false;
	}*/
}
