package test;
import src.ScalableVideo;

public class TestCase2 {
	public static void main(String[] args)throws Exception{
		new TestCase2().startAlgo();
	}
	public void startAlgo()throws Exception{
		int NC = 1;int TC=2; long stime =0; int qlty =0;
		ScalableVideo[][] tsv = TestCase0.getNTData(NC,TC);
		int cap = 10000;
		for(int sec=0;sec<tsv.length;sec++){
			double minQ,maxQ; minQ=  maxQ = 0.0;
			ScalableVideo[] sv = tsv[sec];
			/*int base_rate = 0;
			double[][] node = new double[sv.length][];
			for(int i=0;i<sv.length;i++){
				base_rate= base_rate+sv[i].getRate(0);
				minQ = minQ+ sv[i].getPSNR(0);
				node[i] = new double[sv[i].numL-1];
				int temp_rate = sv[i].getRate(0);
				double temp_qty = sv[i].getPSNR(0);
				for(int j=1;j<sv[i].numL;j++){
					temp_rate = temp_rate+sv[i].getRate(j);
					temp_qty =  temp_qty+sv[i].getPSNR(j);
					node[i][j-1] =temp_qty/temp_rate;
				}
				maxQ = maxQ+ temp_qty;
				//System.out.println("BR="+base_rate+" minQ="+minQ+" maxQ="+maxQ);
			}
			//minQ = minQ/sv.length; maxQ = maxQ/sv.length;*/
			test_ba_mckp(sv);
		}
	}
	public void heu_knapsack(int cap, double LB,double UB, double[][] r,ScalableVideo[] sv)throws Exception{
		double gap = UB-LB;
		
		double epsilon = 0.6; int itr=0;
		while((itr<100) && (UB-LB)>(1)){
			double X = (UB-LB)/2;
			System.out.println("cap="+cap+" UB="+UB+" LB="+LB+" gap ="+(UB-LB)+" X["+itr+"]="+X);
			//braching algorithm
			boolean leq = BA(r,X,cap,sv);
			if(leq == true) UB = UB-X;
			else LB=LB+X;
			itr++;
		}
		System.out.println("L="+LB);
	}
	public boolean BA(double[][] r,double x,int P,ScalableVideo[] sv){
		int[][] f = new int[r.length][2]; double sum =0.0;
		//step 1
		for(int i=0;i<r.length;i++){
			//int[] list = {0,0,0,0};
			double max = Double.MIN_VALUE; int idx =0;
			for(int j=0;j<r[i].length;j++){
				 if((r[i][j] > (x*sv[i].getRate(idx+1)/10000)) && (r[i][j]> max)){
					 max = r[i][j];
					 idx=j;
				 } 
				 System.out.print(" L["+j+"]="+r[i][j]+" idx="+idx);
			}
			sum = sum + sv[i].getPSNR(idx+1);
			System.out.println(" C["+i+"]="+sv[i].getPSNR(idx+1)+" sum="+sum);
		}
		//step 2
		boolean leq = (sum > x) ? false: true;
		return leq;
	}
	/*public void test3()throws Exception{
		int P =200;
		int F = 50;
		int t = 5;
		int Q = 100;
		ScalableVideo[] sv = test2();
		int[] sol = {4,4,4,2,4,4,2,4,2,4};
		float[] u = new float[sv.length];
		Job[] job  = new Job[sv.length];
		float[] r = new float[sv.length];
		float[] B = new float[sv.length];
		int[] b = new int[sv.length];
		int[] k = new int[sv.length];
		int[][] y = new int[sv.length][];
		int[][] x = new int[sv.length][];
		int[][] z = new int[sv.length][];
		int[][] e = new int[sv.length][];
		PriorityQueue<SubFrame> pq = new PriorityQueue<SubFrame>(); int tot=0;
		for(int i=0;i<sv.length;i++){
			r[i] = (float)(sv[i].getRate(sol[i]-1)*0.001);
			u[i] = r[i]*1000/2;
			job[i] = new Job(i,Math.round(u[i]/(r[i]*t)),sv[i].numF[sol[i]-1]);
			//pq.add(job[i]);
			b[i] = sv[i].numF[sol[i]-1];
			B[i] = 0;
			k[i] = (b[i]*F)/Q; if(((b[i]*F)%Q)!=0)k[i]++;
			y[i] = new int[k[i]];
			x[i] = new int[k[i]];
			z[i] = new int[k[i]];
			for(int j=0;j<k[i]-1;j++){
				y[i][j] = Q/F;
				x[i][j] = j*Q/b[i];
				z[i][j] = ((j+1)*Q)/b[i];
			}

			y[i][k[i]-1] =((b[i]*F)%Q==0) ? Q/F : b[i]-(k[i]-1)*Q/F;
			x[i][k[i]-1] = k[i]*Q/b[i];
			z[i][k[i]-1] = ((b[i]*F)%Q==0) ? ((k[i]+1)*Q)/b[i] : P;
			System.out.println(i+"["+k[i]+" : "+r[i]+" : "+u[i]+" : "+b[i]+"] ");
			for(int j=0;j<k[i];j++){
				System.out.print("["+x[i][j]+" "+y[i][j]+" "+z[i][j]+"]");
				pq.add(new SubFrame(i,j,x[i][j],y[i][j],z[i][j],0));
			}
			tot =tot+k[i];
			System.out.println();
		}
		System.out.println("total k= "+tot);
		int[] slot = new int[P];
		for(int p=0;p<P;p++){
			SubFrame curr = pq.peek();
			if(isDPoint(p,x,curr)){
				curr = pq.peek();
				if(curr.getA()>=curr.getY())curr = pq.poll();
				else {
					int temp = curr.getA();
					curr.setA(temp++);
				}
				slot[p] = curr.getS();
			}
		}
		for(int p=0;p<P;p++){
			System.out.print(" "+slot[p]);
		}
		
	}
	public boolean isDPoint(int p,int[][] x,SubFrame cur){
		if(cur.getA()>=cur.getY())	return true;
		for(int s=0;s<x.length;s++)
			for(int k =0;k<x[s].length;k++)
				if(x[s][k]==p) return true;
		return false;
	}*/
	public void test_ba_mckp(ScalableVideo[] sv)throws Exception{
		int m =6; int n =8; int b =102;
		int[] N = {1,1,1,1,2,2};
		double[][] c = new double[m][];
		double[][] a = new double[m][];
		double L = 100; double U=m*L;
		/*for(int i =0;i<m;i++){
			c[i] = new double[N[i]];
			a[i] = new double[N[i]];
		}
		c[0][0]=15;c[1][0]=100;c[2][0]=90;c[3][0]=60;
		c[4][0]=40;c[4][1]=15;c[5][0]=10;c[5][1]=1;
		a[0][0]=2;a[1][0]=20;a[2][0]=20;a[3][0]=30;
		a[4][0]=40;a[4][1]=30;a[5][0]=60;a[5][1]=10;
		
		while((U/L)>5){
			double x = U/2;
			//braching algorithm
			boolean isLess = BA(c,a,x,b);
		if(isLess) U = 0.8*U;
		else L=0.2*U;
		System.out.println("f* <= x(1+ep)="+isLess+" U="+U+" L="+L);
		}*/
		
		//System.out.println("\nsv:");
		//ScalableVideo[] sv = TestCase0.getData(0);
		m = sv.length; b = 10000; double max_cij =Double.MIN_VALUE;
		c = new double[m][];a = new double[m][];
		for(int i =0;i<m;i++){
			c[i] = new double[sv[i].numL];
			a[i] = new double[sv[i].numL];
			for(int j=0;j<sv[i].numL;j++){
				c[i][j] = sv[i].getPSNR(j);
				a[i][j] = sv[i].getRate(j);
				if(c[i][j]>max_cij)max_cij = c[i][j];
				//System.out.print("["+c[i][j]+","+a[i][j]+"]");
			}
			//System.out.println();
		}
		L = max_cij; U = m*max_cij; 
		//System.out.println(" U="+U+" L="+L +" x="+(U/2));
		do{
			double x = U/2;
			//braching algorithm
			double[] sol = BA(c,a,x,b);
		if(sol[0]>0.0) U = 0.9*U;
		else L=0.1*U;
		System.out.println(/*"f* <= x(1+ep)="+sol[0]+" U="+U+*/" L="+max_cij+" sol="+sol[1]);
		if((U/L)<=5)break;
		}while(true);
	}
	public double[] BA(double[][] c,double[][] a, double x,int b){
		int[][] list = new int[a.length][];
		double sum_cij =0;
		//step 1
		for(int i=0;i<a.length;i++){
			list[i] = new int[a[i].length];
			for(int j=0;j<a[i].length;j++){
				if((c[i][j]/a[i][j])>=(0.4*x/b)) list[i][j]=1;
			}
		}
		for(int i=0;i<list.length;i++){
			double max = Double.MIN_VALUE; int idx =0;
			for(int j=0;j<list[i].length;j++)
				if(list[i][j] == 1 && c[i][j]>max){max = c[i][j];idx = j;}//System.out.print("["+i+","+j+"]");}
			list[i][idx]=2;
		}
		//System.out.println();
		for(int i=0;i<list.length;i++){
			for(int j=0;j<list[i].length;j++)
				if(list[i][j] == 2 ){sum_cij = sum_cij + c[i][j];}//System.out.print("["+i+","+j+"]");} 
		}
		//System.out.println();
		//System.out.println("sum_cij="+sum_cij+" 0.8x="+(0.8*x));
		double[] sol = new double[2];	
		if(sum_cij > (0.4*x)) sol[0]=0.0;
		else sol[0]=1.0;
		sol[1] = sum_cij;
		return sol;
	}
}
