package test;
import java.io.File;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.util.*;

import src.*;

public class TestCase3 {
	int wt =0;double pft=0.0;
	public static void main(String[] args)throws Exception{
		new TestCase3().bq_sch();
		//new TestCase3().dummy_instance();
	}
	public  void dummy_instance()throws Exception{
		int[] rates0 = {Integer.MAX_VALUE,Integer.MAX_VALUE,Integer.MAX_VALUE,Integer.MAX_VALUE,Integer.MAX_VALUE};
		int[] rates1 = {100,205,295,400};
		double[] buff = {0.0,0.0,0.0,0.0};
		new File("buf_state0.csv").delete();
		PrintWriter pw = new PrintWriter(new FileWriter("buf_state0.csv"));
		BVFSol sol = bvfs1(rates0,rates1,buff,pw);
		buff = sol.getBuff();
		int[] rates2 = {300,200,300,200};
		sol = bvfs1(rates1,rates2,buff,pw);
		pw.close();
	}
	public  void bq_sch()throws Exception{
		ScalableVideo[][] tsv = TestCase0.getNTData(1,30);
		//ScalableVideo[] mvid = TestCase0.getData(0);for(int i=0;i<mvid.length;i++){mvid[i].print();}
		int[] prev_rates = new int[tsv[0].length];
		double[] buff = new double[tsv[0].length];
		for(int s=0;s<buff.length;s++){buff[s]=0.0;prev_rates[s]=Integer.MAX_VALUE;}
		new File("buf_state.csv").delete();
		PrintWriter pw_buff = new PrintWriter(new FileWriter("buf_state.csv"));
		new File("power_usage.csv").delete();
		PrintWriter pw_power = new PrintWriter(new FileWriter("power_usage.csv"));
		for(int t=0;t<tsv.length;t++){
			System.out.print(t+"=");
			boolean isfeas = false; 
			int cap = 10*1000;//kbytes
			ScalableVideo[] sv = tsv[t];
			int[] maxl = solve_knapsack2(sv,cap);
			//for(int i=0;i<maxl.length;i++)System.out.print(" "+maxl[i]);System.out.println();
			//int nitr=0;
			//while(isfeas == false && nitr<35){
				int[] maxrates = new int[sv.length];
				for(int s=0;s<sv.length;s++)
						maxrates[s] = sv[s].getRate(maxl[s]);
				//for(int i=0;i<maxrates.length;i++)System.out.print(" "+maxrates[i]);System.out.println();		
				isfeas = bvfs2(prev_rates,maxrates,buff,pw_buff,pw_power).isFeas();
				//prev_rates = maxrates;
				//cap = wt-1;
				//maxl = solve_knapsack1(sv,cap);
				//nitr++;
			//}				
		}
		pw_buff.close();
		pw_power.close();
	}
	/*
	public  KnapsackSolution solve_knapsack(ScalableVideo[] sv, int Wcap)throws Exception{
		int tbr = 0; double tbq = 0.0;
		for(int i=0;i<sv.length;i++){
			tbr = tbr + sv[i].getRate(0);
			tbq = tbq + sv[i].getPSNR(0);
		}
		System.out.println("Wcap="+Wcap+" (Wcap-base)="+(Wcap -tbr));
		Wcap = Wcap -tbr;
		PriorityQueue<Key> pdPQ = new PriorityQueue<Key>();
		for(int i=0;i<sv.length;i++){
			int br = sv[i].getRate(0);
			double bq = sv[i].getPSNR(0);
			for(int j=1;j<sv[i].numL;j++){
				br = br +sv[i].getRate(j);
				bq = bq+ sv[i].getPSNR(0);
				double qpur = bq/br;
				pdPQ.add(new Key(qpur,i,j,sv[i].getRate(j)));
			}
		}
		int w = 0; int brs= tbr;
		int[] sol = new int[sv.length];
		int[][] osol = new int[sv.length*4][];int idx=0;
		for(int s=0;s<sv.length;s++){sol[s]=0;}
		int[] last ={0,0}; 
		while(!pdPQ.isEmpty()){
			Key K = pdPQ.poll();
			if((w+K.getV3())>Wcap)break;
			else{
				System.out.print(K.getV1()+" "+K.getV2()+" "+K.getV3()+" "+sol[K.getV1()]);
				if(K.getV2()>sol[K.getV1()])sol[K.getV1()] = K.getV2();
				tbr = tbr + K.getV3();
			tbq = tbq + sv[K.getV1()].getPSNR(K.getV2());
			System.out.println(" w="+w+" (w)="+(w +K.getV3()));
			w = w+K.getV3();
			osol[idx] = new int[2];osol[idx][0]=K.getV1();osol[idx][1]= K.getV2();
			idx++;
			}
		}
		int[][] tsol = new int[idx][];
		for(int i=0;i<idx;i++)tsol[i]=osol[i];
		for(int s=0;s<sv.length;s++){System.out.print("["+(s)+","+sol[s]+"]");}
		System.out.println("\n Avg PSNR:"+tbq/sv.length+" kp_data_rate="+(w+brs));
		KnapsackSolution kps =new KnapsackSolution(tsol,tbq/sv.length);
		kps.setMax(sol);
		return kps;
	}
	*/
	public  int[] solve_knapsack2(ScalableVideo[] sv, int Wcap)throws Exception{
		PriorityQueue<Layers> slst = new PriorityQueue<Layers>();
		for(int i=0;i<sv.length;i++){
			for(int j=1;j<sv[i].numL;j++)
				slst.add(new Layers(i,j,sv[i].getRate(j),sv[i].getPSNR(j)));
		}
		int w = 0; Wcap = Wcap/Param.F;
		int[] max = new int[sv.length];
		int[] blk = new int[sv.length];
		for(int i=0;i<sv.length;i++){
			max[i] = 0;
			blk[i] = (int)Math.ceil(1.0*sv[i].getRate(0)/Param.F);
			w = w+ blk[i];
		}
		
		//System.out.println("w="+w+" Wcap="+Wcap);
		while(!slst.isEmpty()){
			//ppqq(slst);
			Layers lr = slst.peek();
			int toBw = w = w+lr.getNumB() - blk[lr.getSID()];blk[lr.getSID()]=lr.getNumB();
			if( toBw > Wcap)break;
			else{
				w = toBw;
				slst.poll();
				if(lr.getLID() >max[lr.getSID()])max[lr.getSID()] = lr.getLID();
			}
			//for(int i=0;i<sv.length;i++)
				//System.out.print("["+i+","+max[i]+"]");
			//System.out.println("\n=============== w[/"+Wcap+"]="+w);
			
		}
		int numb =0; int rate=0; double qty = 0.0;
		for(int i=0;i<sv.length;i++){
			Layers lrs = new Layers(i,max[i],sv[i].getRate(max[i]),sv[i].getPSNR(max[i]));
			//System.out.print("["+i+","+max[i]+","+lrs.getNumB()+"]");
			numb = numb + (int)Math.ceil(1.0*sv[i].getRate(max[i])/Param.F);
			rate = rate + sv[i].getRate(max[i]);
			qty = qty + sv[i].getPSNR(max[i]);
		}
		//System.out.println("\n Avg PSNR:"+qty/sv.length+" data rate="+rate+" blocks="+numb);
		return max;
	}
	public void ppqq(PriorityQueue<Layers> pq){
		PriorityQueue<Layers> tq = new PriorityQueue<Layers>(pq);
		while(!tq.isEmpty()){
			Layers s = tq.poll();
			System.out.println(s);
		}
		System.out.println("--------------");
	}
	public  int[] solve_knapsack1(ScalableVideo[] sv, int Wcap)throws Exception{
		//Construct the tree represenstation
		ArrayList<Layer> L = new ArrayList<Layer>();
		Layer root = new Layer(0,0,1,0.01);L.add(root);
		for(int i=0;i<sv.length;i++){
			Layer row = new Layer(i,0,sv[i].getRate(0),sv[i].getPSNR(0));
			L.add(row);
			row.setPre(root);row.setCSuc(null);row.setRSuc(null);
			root.setRSuc(row);
			Layer pre = row;
			for(int j=1;j<sv[i].numL;j++){
				Layer el = new Layer(i,j,sv[i].getRate(j),sv[i].getPSNR(j));
				L.add(el);
				el.setPre(pre);
				el.setCSuc(null);
				el.setRSuc(null);
				pre.setCSuc(el);
				pre = el;
			}
			root = row;
		}
		/*for(int i=0;i<L.size();i++)
			System.out.println(L.get(i)+"  "+L.get(i).getPre()+"  "+L.get(i).getRSuc()+"  "+L.get(i).getCSuc());
		System.out.println("\n\n");*/
		//traverse the tree to find the best layers
		ArrayList<Layer> visited = new ArrayList<Layer>();
		visited.add(L.get(0));L.get(0).setVisited(true); 
		int w = L.get(0).getRate(); int numf =0; 
		while(w<Wcap ){
			/*System.out.print("Visited: ");
			for(int i=0;i<visited.size();i++)
				System.out.print(visited.get(i));
			System.out.println();*/
			ArrayList<Layer> incumbent = new ArrayList<Layer>();
			for(int i=0;i<visited.size();i++){
				if(visited.get(i).getCSuc() != null && visited.get(i).getCSuc().isVisited() != true) incumbent.add(visited.get(i).getCSuc());
				if(visited.get(i).getRSuc() != null && visited.get(i).getRSuc().isVisited() != true) incumbent.add(visited.get(i).getRSuc());
			}
			/*System.out.print("Incumbent: ");
			for(int i=0;i<incumbent.size();i++)
				System.out.print(incumbent.get(i));
			System.out.println();*/
			double max = Integer.MIN_VALUE; int max_idx = 0;
			for (int i=0;i<incumbent.size();i++)
				if(max < (incumbent.get(i).getPsnr()/incumbent.get(i).getRate())){
					max = incumbent.get(i).getPsnr()/incumbent.get(i).getRate();
					max_idx = i;
				}
			//System.out.println("\n max_idx:"+max_idx);
			Layer best_layer = incumbent.get(max_idx);
			if((w+ best_layer.getRate())>Wcap)
				break;
			else{
				best_layer.setVisited(true);
				w = w+best_layer.getRate();
				numf = numf+best_layer.getF();
				visited.add(best_layer);
			}
		}
		//System.out.print("Solution["+w+"/"+numf+"]: ");
		double q =0.0; int rate =0;
		
		int[] max= new int[sv.length];
		for(int i=0;i<sv.length;i++){max[i]=-1;}
		for(int i=0;i<visited.size();i++){
			//System.out.print("["+visited.get(i).getSID()+" "+visited.get(i).getLID()+"]");
			if(visited.get(i).getLID()>max[visited.get(i).getSID()])max[visited.get(i).getSID()]=visited.get(i).getLID();
			q = q+visited.get(i).getPsnr();
			rate = rate + visited.get(i).getRate();
		}
		//System.out.println();
		for(int i=0;i<sv.length;i++){System.out.print("["+i+","+max[i]+"]");}
		System.out.println("\n Avg PSNR:"+q/sv.length+" data rate="+rate);
		wt = rate;pft=q/sv.length;
		return max;
	}
	public BVFSol bvfs2(int[] prev_r,int[] r,double[] Buff,PrintWriter pwbf,PrintWriter pwpr)throws Exception{
		int P =200;
		int F = 50;
		double t = 0.005;
		int Q = 500;
		int[] b = new int[r.length];
		int[] kmin = new int[r.length];
		SubFrame[][] sbfm = new SubFrame[r.length][]; 
		boolean islate = false;
		
		int[] dp = new int[P];
		for(int i=0;i<P;i++)dp[i]=0;
		int totk=0;int totb=0; 
		//for(int i=0;i<r.length;i++)System.out.print(" "+r[i]);System.out.println();
		for(int i=0;i<r.length;i++){
			//System.out.print("P*t*sr["+(i+1)+"]="+(P*t*r[i]) +" /F="+(int)Math.ceil((1.0*P*t*r[i]/F)));
			b[i] = (int)Math.ceil((1.0*P*t*r[i])/F);
			//System.out.println(" b="+b[i]);
			totb = totb + b[i];
		}
		//System.out.println(" Total blocks= "+totb);
		PriorityQueue<SubFrame> wksPQ = new PriorityQueue<SubFrame>();
		double[] cover = new double[r.length];
		for(int i=0;i<r.length;i++){cover[i] = Buff[i];}
		for(int i=0;i<r.length;i++){
			//System.out.print(" "+(b[i]*F/Q));
			kmin[i] = (b[i]*F)/Q; 
			//System.out.print(" "+((b[i]*F)%Q));
			if(((b[i]*F)%Q)!=0)kmin[i]++;
			//System.out.println(" "+kmin[i]+" ");
			int k = (2*b[i]*F)/Q; if(((2*b[i]*F)%Q)!=0)k++;
			sbfm[i] = new SubFrame[k];
			for(int j=0;j<k;j++){
				int yij = Q/(2*F);
				int xij = (int)Math.floor((j*Q)/(2.0*r[i]*t));
				int zij = (int)Math.floor(((j+1)*Q)/(2.0*r[i]*t));
				sbfm[i][j] = new SubFrame(i,j, xij,yij,zij);
				//System.out.println("z"+z[i][j]+" x"+x[i][j]+" r"+((z[i][j]-x[i][j])*t*r[i])+" y"+(y[i][j]*F)+" C="+cover[i]+" ");}
			}
			int x0 =((Buff[i]<0)? 0:((int)Math.floor((Buff[i])/(prev_r[i]*t))));
			//System.out.print(" X0="+x0+" ");
			int yk = b[i]-(k-1)*(Q/(2*F));
			int zk = P-1;
			sbfm[i][0].setX(x0);sbfm[i][k-1].setY(yk);sbfm[i][k-1].setZ(zk);
			//if((b[i]*F)%Q==0)z[i][k[i]-1]=(int)Math.floor(((k[i]+1)*Q)/(2.0*r[i]*t));
			//else 
			//	z[i][k[i]-1] = P-1;
			
		}//System.out.println();
		for(int i=0;i<r.length;i++){
			//System.out.print("b["+(i+1)+"]="+b[i]+" kmin["+(i+1)+"]="+kmin[i]+" K["+(i+1)+"]="+sbfm[i].length+" :");
			for(int j=0;j<sbfm[i].length;j++){
				//System.out.print(sbfm[i][j]);
				if(dp[sbfm[i][j].getX()]==0) dp[sbfm[i][j].getX()]=1;
				//if(dp[z[i][j]]==0) dp[z[i][j]]=1;
				wksPQ.add(sbfm[i][j]);
			}
			//System.out.println();
		}
		//System.out.println("total k= "+totk+" total b="+totb+" total rate="+totr);
		int[] slot = new int[P]; //int p=0;
		int tc,tn; tc =tn = 0;
		for(int i=0;(i<P)||(wksPQ.isEmpty());){
			//System.out.println("i="+i+" DP[i]="+dp[i]);
			if(dp[i]==1){
				//System.out.println("i="+i+" tc="+tc+" tn="+tn);
				tc = i; //ppq(wksPQ);
				//PriorityQueue<SubFrame> duePQ = getDueQueue(wksPQ,tc);
				if(wksPQ.isEmpty())break;
				SubFrame wks = wksPQ.peek();
				if(wks.getX()>tc){i++;}
				else{
					wks = wksPQ.poll();
					if(tc == P-1){slot[tc] = wks.getS()+1;}
					else{
						tn = tc + wks.getY()-1;
						//System.out.println("i="+i+" tc="+tc+" s="+(wks.getS()+1)+" y="+(wks.getY())+" tn="+tn);
						for(int j =tc;j<=tn;j++) 
							slot[j] = wks.getS()+1;
						//System.out.print("[("+(wks.getS()+1)+","+wks.getK()+") ("+tc+","+(tn-1)+") ("+wks.getX()+","+wks.getZ()+")]");
						//if((tc<wks.getX())||(tn>wks.getZ())){System.out.print("Late");//islate = false;return islate;}
						//System.out.println();
						if(dp[tn+1]==0)dp[tn+1]=1;
						i = tn+1;
						//System.out.println("i="+i+" tc="+tc+" s="+(wks.getS()+1)+" tn="+tn);
						//for(int tp=0;tp<P;tp++)if(dp[tp]==1)System.out.print(" "+tp);System.out.println();
						//for(int tp=0;tp<P;tp++)System.out.print(" "+slot[tp]);System.out.println();
					}
				}
			}
			else i++;
		}
		//System.out.println();
		//for(int p=0;p<P;p++){if(p%40 ==0)System.out.println();System.out.print(" "+slot[p]);}
		//System.out.println();
		double[][] BS = new double[P][r.length]; 
		for(int s =0;s<r.length;s++){
			
			//System.out.println(" u[s]="+BS[0]+" r[s]="+((t/1000.0)*solrate[s]));
			BS[0][s] = (slot[0]==s+1) ? (F -t*r[s]) : Buff[s];
			//if(slot[0]==1) BS[0] = BS[0] + F;
			for(int p=1;p<P;p++){
				//if(BS[p-1][s] == 0.0)
					//BS[p][s] = (slot[p]==s+1) ? (F -t*r[s]) : 0.0;
				//else
					BS[p][s] = (slot[p]==s+1) ? (BS[p-1][s] + F -t*r[s]) : (BS[p-1][s] -t*r[s]);
			}
			//System.out.println();
		}
		for(int p=0;p<P;p++){
			String str= "0";
			for(int s =0;s<r.length;s++){
			//System.out.print(" "+BS[p][s]);
			str = str+","+BS[p][s];
			}
			pwbf.println(str);
			if(p==P-1)System.out.println(str);
		}
		String strp= "0";
		double esav = 0.0;double minsav = 0.0;
		for(int s =0;s<r.length;s++){
			//System.out.print(" "+((b[s]*5+2*sbfm[s].length)/(1000.0)));
			esav = esav + (1 - (b[s]*0.005+0.002*sbfm[s].length));
			minsav = minsav + (1 - (b[s]*0.005+0.002*kmin[s]));
			strp = strp+","+(1 - (b[s]*0.005+0.002*sbfm[s].length));
			}
		strp = strp+","+(esav/r.length)+","+(minsav/r.length);
		pwpr.println(strp);
		BVFSol bvfs = new BVFSol(!islate,BS[P-1],slot);
		return bvfs;
	}
	public BVFSol bvfs1(int[] prev_r,int[] r,double[] Buff,PrintWriter pw)throws Exception{
		int P =200;
		int F = 50;
		double t = 0.005;
		int Q = 500;
		int[] b = new int[r.length];
		int[] kmin = new int[r.length];
		//int[] k = new int[r.length];
		int[][] y = new int[r.length][];
		int[][] x = new int[r.length][];
		int[][] z = new int[r.length][];
		SubFrame[][] sbfm = new SubFrame[r.length][]; 
		boolean islate = false;
		
		int[] dp = new int[P];
		for(int i=0;i<P;i++)dp[i]=0;
		int totk=0;int totb=0; 
		for(int i=0;i<r.length;i++)System.out.print(" "+r[i]);System.out.println();
		for(int i=0;i<r.length;i++){
			//System.out.print("P*t*sr["+(i+1)+"]="+(P*t*r[i]) +" /F="+(int)Math.ceil((1.0*P*t*r[i]/F)));
			b[i] = (int)Math.ceil((1.0*P*t*r[i])/F);
			//System.out.println(" b="+b[i]);
			totb = totb + b[i];
		}
		System.out.println(" Total blocks= "+totb);
		PriorityQueue<SubFrame> wksPQ = new PriorityQueue<SubFrame>();
		double[] cover = new double[r.length];
		for(int i=0;i<r.length;i++){cover[i] = Buff[i];}
		for(int i=0;i<r.length;i++){
			//System.out.print(" "+(b[i]*F/Q));
			kmin[i] = (b[i]*F)/Q; 
			//System.out.print(" "+((b[i]*F)%Q));
			if(((b[i]*F)%Q)!=0)kmin[i]++;
			//System.out.println(" "+(kmin[i]));
			int k = (2*b[i]*F)/Q; if(((b[i]*F)%Q)!=0)k++;
			sbfm[i] = new SubFrame[k];
			for(int j=0;j<k;j++){
				int yij = Q/(2*F);
				int xij = (int)Math.floor((j*Q)/(2.0*r[i]*t));
				int zij = (int)Math.floor(((j+1)*Q)/(2.0*r[i]*t));
				sbfm[i][j] = new SubFrame(i,j, xij,yij,zij);
				//System.out.println("z"+z[i][j]+" x"+x[i][j]+" r"+((z[i][j]-x[i][j])*t*r[i])+" y"+(y[i][j]*F)+" C="+cover[i]+" ");}
			}
			int x0 =((Buff[i]<0)? 0:((int)Math.floor((Buff[i])/(prev_r[i]*t))));
			System.out.print(" X0="+x0+" ");
			int yk = b[i]-(k-1)*(Q/(2*F));
			int zk = P-1;
			sbfm[i][0].setX(x0);sbfm[i][k-1].setY(yk);sbfm[i][k-1].setZ(zk);
			//if((b[i]*F)%Q==0)z[i][k[i]-1]=(int)Math.floor(((k[i]+1)*Q)/(2.0*r[i]*t));
			//else 
			//	z[i][k[i]-1] = P-1;
			
		}System.out.println();
		for(int i=0;i<r.length;i++){
			System.out.print("b["+(i+1)+"]="+b[i]+" kmin["+(i+1)+"]="+kmin[i]+" K["+(i+1)+"]="+sbfm[i].length+" :");
			for(int j=0;j<sbfm[i].length;j++){
				System.out.print(sbfm[i][j]);
				if(dp[sbfm[i][j].getX()]==0) dp[sbfm[i][j].getX()]=1;
				//if(dp[z[i][j]]==0) dp[z[i][j]]=1;
				wksPQ.add(sbfm[i][j]);
			}
			System.out.println();
		}
		//System.out.println("total k= "+totk+" total b="+totb+" total rate="+totr);
		int[] slot = new int[P]; //int p=0;
		int tc,tn; tc =tn = 0;
		for(int i=0;(i<P)||(wksPQ.isEmpty());){
			//System.out.println("i="+i+" DP[i]="+dp[i]);
			if(dp[i]==1){
				//System.out.println("i="+i+" tc="+tc+" tn="+tn);
				tc = i; //ppq(wksPQ);
				//PriorityQueue<SubFrame> duePQ = getDueQueue(wksPQ,tc);
				if(wksPQ.isEmpty())break;
				SubFrame wks = wksPQ.peek();
				if(wks.getX()>tc){i++;}
				else{
					wks = wksPQ.poll();
					if(tc == P-1){slot[tc] = wks.getS()+1;}
					else{
						tn = tc + wks.getY()-1;System.out.println("i="+i+" tc="+tc+" s="+(wks.getS()+1)+" y="+(wks.getY())+" tn="+tn);
						for(int j =tc;j<=tn;j++) 
							slot[j] = wks.getS()+1;
						//System.out.print("[("+(wks.getS()+1)+","+wks.getK()+") ("+tc+","+(tn-1)+") ("+wks.getX()+","+wks.getZ()+")]");
						//if((tc<wks.getX())||(tn>wks.getZ())){System.out.print("Late");//islate = false;return islate;}
						//System.out.println();
						if(dp[tn+1]==0)dp[tn+1]=1;
						i = tn+1;
						//System.out.println("i="+i+" tc="+tc+" s="+(wks.getS()+1)+" tn="+tn);
						//for(int tp=0;tp<P;tp++)if(dp[tp]==1)System.out.print(" "+tp);System.out.println();
						//for(int tp=0;tp<P;tp++)System.out.print(" "+slot[tp]);System.out.println();
					}
				}
			}
			else i++;
		}
		System.out.println();
		for(int p=0;p<P;p++){
			if(p%40 ==0)System.out.println();
			System.out.print(" "+slot[p]);
			
		}
		System.out.println();
		double[][] BS = new double[P][r.length]; 
		for(int s =0;s<r.length;s++){
			
			//System.out.println(" u[s]="+BS[0]+" r[s]="+((t/1000.0)*solrate[s]));
			BS[0][s] = (slot[0]==s+1) ? (F -t*r[s]) : Buff[s];
			//if(slot[0]==1) BS[0] = BS[0] + F;
			for(int p=1;p<P;p++){
				//if(BS[p-1][s] == 0.0)
					//BS[p][s] = (slot[p]==s+1) ? (F -t*r[s]) : 0.0;
				//else
					BS[p][s] = (slot[p]==s+1) ? (BS[p-1][s] + F -t*r[s]) : (BS[p-1][s] -t*r[s]);
			}
			//System.out.println();
		}
		for(int p=0;p<P;p++){
			String str= "0";
			for(int s =0;s<r.length;s++){
			//System.out.print(" "+BS[p][s]);
			str = str+","+BS[p][s];
			}
			pw.println(str);
			if(p==P-1)System.out.println(str);
		}
		
		BVFSol bvfs = new BVFSol(!islate,BS[P-1],slot);
		return bvfs;
	}
	public void ppq(PriorityQueue<SubFrame> pq){
		PriorityQueue<SubFrame> tq = new PriorityQueue<SubFrame>(pq);
		while(!tq.isEmpty()){
			SubFrame s = tq.poll();
			System.out.println("Q"+s);
		}
		System.out.println("=========");
	}
	public PriorityQueue<SubFrame> getDueQueue(PriorityQueue<SubFrame> wksPQ,int tc){
		PriorityQueue<SubFrame> duPQ = new PriorityQueue<SubFrame>();
		PriorityQueue<SubFrame> tPQ = new PriorityQueue<SubFrame>(wksPQ);
		while(!tPQ.isEmpty()){
			SubFrame wks = tPQ.poll();
			if(wks.getX()<=tc){
				System.out.println(wks);
				duPQ.add(wks);
			}
		}
		return duPQ;
	}


}

